
//.....:::::RIVERA CRESPO ANTONIO:::::.....
//PROGRAMA CON 4 RUTINAS ACTIVADAS MEDIANTE DIP SWITCH R4 Y R3. R2 Y R1 DEBEN PERMANECER ENCENDIDO (1).
//EL PROGRAMA VERIFICA CONSTANTEMENTE LAS ENTRADAS DE LOS DIP SWITCH R4 Y R3 Y DEPENDIENDO DE
//SU POSICION EJECUTA UNA RUTINA:
//R4=1 Y R3=1 -->  MUESTRA MENSAJE EN DISPLAY CON CORRIMIENTO     
//R4=0 Y R3=1 -->  MUESTRA MENSAJE2 EN DISPLAY CON CORRIMIENTO
//R4=0 Y R3=0 -->  MUESTRA CUENTA BINARIA EN PORTB Y EN DISPLAY MUESTRA MENSAJE "CUENTA BINARIA"
//R4=1 Y R3=0 -->  MUESTRA CORRIMIENTO DE LED EN PORTB Y EN DISPLAY MUESTRA MENSAJE "CORRIMIENTO"


#include <htc.h>                 //ARCHIVO HEADER DEL MICROCONTROLADOR 16F88
#include "key34.h"               //CONTIENE LA FUNCION DelayMs( ). 

main(void){                      //AQUI EMPIEZA EL PROGRAMA PRINCIPAL

//".....Rivera Crespo Antonio Microcomputadoras Ingenieria en Computacion.....";

const char wav[200]="................MENSAJE CON CORRIMIENTO 1................";
const char wav2[200]="................MENSAJE CON CORRIMIENTO 2................";
char web[20];
int a=0,b=0,i;

SPEN=0;                          //DESHABILITA UART
CMCON=7;                         //DESHABILITA COMPARADORES ANALOGICOS
CVRCON=0;                        //DESHABILITA VOLTAJE DE REFERENCIA
ANSEL=0;                         //DESHABILITA CONVERTIDORES A/D
TRISA=0X18;                      //RA0 SE INICIALIZA COMO SALIDA, RA3 y RA4 COMO ENTRADAS
TRISB=0x00;                      //TODOS LOS BITS DEL PUERTO B SE INICIALIZA COMO SALIDAS.
PORTB=0;                         //SE APAGAN TODOS LOS LEDS
RA0=0;                           //SE DESACTIVA EL RELEVADOR
InitIO();
ClearScreen();

   while(1){                     //AQUI INICIA EL LOOP DEL PROGRAMA
                                 
inicio:
//-------------------CODIGO PARA PRIMER MENSAJE CON CORRIMIENTO----------------------------------
  if (RA4==1&&RA3==1){                
           b=b+1;
           for(a=0;a<16;a++)		//CARGA MENSAJE DE BUFFER PRINCIPAL
               {
                if(RA4==0||RA3==0){goto inicio;}
                web[a]=wav[a+b];}
                GotoXY(0,0);			//ESCRIBE EN RENGLON 0, 8 CARACTERES
            for(a=0;a<8;a++)
               {
               if(RA4==0||RA3==0){goto inicio;}
               PutChar(web[a]);}
               GotoXY(1,0);			//ESCRIBE EN RENGLON 1, 8 CARACTERES
               for(a=8;a<16;a++)
               {
               if(RA4==0||RA3==0){goto inicio;}
               PutChar(web[a]);}

               DelayMs(80);
               if(wav[b+16]==0)b=0;
               goto inicio;
        }  
//-------------CODIGO PARA SEGUNDO MENSAJE CON CORRIMIENTO---------------------------------------
    else if(RA4==0&&RA3==1)                     
              {
               b=b+1;
               for(a=0;a<16;a++)		
                   {
                    if(RA4==1||RA3==0){goto inicio;}
                    web[a]=wav2[a+b];}
                    GotoXY(0,0);			
              for(a=0;a<8;a++)
                 {
                 if(RA4==1||RA3==0){goto inicio;}
                 PutChar(web[a]);}
                 GotoXY(1,0);		
                 for(a=8;a<16;a++)
                 {
                 if(RA4==1||RA3==0){goto inicio;}
                 PutChar(web[a]);}

                 DelayMs(50);
                 if(wav2[b+16]==0)b=0;   
                 goto inicio;              
        }
//-------------CODIGO PARA CUENTA BINARIA PORTB---------------------------------------
      else if(RA4==0&&RA3==0){
             ClearScreen();
             GotoXY(0,0);
		     PrintString(" Cuenta");
             GotoXY(1,0);
		     PrintString(" Binaria");

             PORTB=0;
          for (i=0;i<256;i++){
            PORTB++;
            DelayMs(50);
            if(RA4==1||RA3==1){goto inicio;}
          }
        goto inicio;
}
//-------------CODIGO PARA CORRIMIENTO DE LED PORTB---------------------------------------
else{
          ClearScreen();
          GotoXY(0,0);
	      PrintString(" Corrimi");
          GotoXY(1,0);
	      PrintString("ento");
          PORTB=1;
          DelayMs(50);
          
       for (i=0;i<500;i++){
            PORTB=PORTB*2 ;
            DelayMs(50);
            if (PORTB==128){PORTB=1; DelayMs(50); }
            if(RA4==0||RA3==1){goto inicio;}
	 	}
goto inicio;
   }
  }
 }
                             
